Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-1.5x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -29,3 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
-
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 4.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BQTerrace_1920x1080_60.yuv
@@ -29,2 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-1.5x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -29,3 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
-
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : BasketballDrive_1920x1080_50.yuv
@@ -29,2 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-1.5x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -29,3 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
-
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-Level                         : 4.1
+#Level                         : 4.1
+#This is level of the whole bitstream
+Level0                         : 4.1
+#This is level of the base layer
+Level1                         : 4.1
+#This is level of the enhancement layer
+Level2                         : 4.1
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Cactus_1920x1080_50.yuv
@@ -29,2 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-1.5x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Kimono1_1920x1080_24.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : O:/Kimono1_1920x1080_24.yuv
@@ -29,2 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 941)
@@ -1,5 +1,12 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 4
+#This is level of the enhancement layer
+Level2                         : 4
+
 
 #======== File I/O ===============
@@ -13,4 +20,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Kimono1_1920x1080_24.yuv
@@ -29,2 +37,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-1.5x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 941)
@@ -1,6 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
-
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 4
 #======== File I/O ===============
 InputFile0                    : ParkScene_960x544_24_zerophase_0.9pi.yuv
@@ -13,4 +18,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -29,2 +35,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-Level                         : 4
+#Level                         : 4
+#This is level of the whole bitstream
+Level0                         : 4
+#This is level of the base layer
+Level1                         : 4
+#This is level of the enhancement layer
+Level2                         : 4
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : ParkScene_1920x1080_24.yuv
@@ -29,2 +36,3 @@
 ResamplePhaseSetPresentFlag1     : 0        # List of resample phase set present flags
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-2x.cfg	(revision 941)
@@ -1,6 +1,13 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-Level                         : 5
+#Level                         : 5
+#This is level of the whole bitstream
+Level0                         : 5
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 5
 
+#======
 #======== File I/O ===============
 InputFile0                    : PeopleOnStreet_1280x800_30_crop_zerophase_0.9pi.yuv
@@ -13,4 +20,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : PeopleOnStreet_2560x1600_30_crop.yuv
@@ -23,2 +31,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/PeopleOnStreet-SNR.cfg	(revision 941)
@@ -1,6 +1,13 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-Level                         : 5
+#Level                         : 5
+#This is level of the whole bitstream
+Level0                         : 5
+#This is level of the base layer
+Level1                         : 5
+#This is level of the enhancement layer
+Level2                         : 5
 
+#======
 #======== File I/O ===============
 InputFile0                    : PeopleOnStreet_2560x1600_30_crop.yuv
@@ -13,4 +20,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : PeopleOnStreet_2560x1600_30_crop.yuv
@@ -23,2 +31,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-2x.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-Level                         : 5
+#Level                         : 5
+#This is level of the whole bitstream
+Level0                         : 5
+#This is level of the base layer
+Level1                         : 3.1
+#This is level of the enhancement layer
+Level2                         : 5
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Traffic_2560x1600_30_crop.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg	(revision 911)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Traffic-SNR.cfg	(revision 941)
@@ -1,5 +1,11 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-Level                         : 5
+#Level                         : 5
+#This is level of the whole bitstream
+Level0                         : 5
+#This is level of the base layer
+Level1                         : 5
+#This is level of the enhancement layer
+Level2                         : 5
 
 #======== File I/O ===============
@@ -13,4 +19,5 @@
 ConformanceMode0              : 1           # conformance mode
 QP0                           : 22
+LayerPTLIndex0                : 1 
 
 InputFile1                    : Traffic_2560x1600_30_crop.yuv
@@ -23,2 +30,3 @@
 ConformanceMode1              : 1           # conformance mode
 QP1                           : 20
+LayerPTLIndex1                : 2 