Index: branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b10-1x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-Birthday-b8-2x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b10-1x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart1-b8-2x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b10-1x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-BirthdayFlashPart2-b8-2x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b10-1x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 250         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-Parakeets-b8-2x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 250         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b10-1x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/CGS-TableCar-b8-2x.cfg	(revision 944)
@@ -2,5 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 300         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Cactus-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4.1
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 4
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 5
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 5
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Traffic-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 5
 #This is level of the whole bitstream
Index: branches/SHM-dev/cfg/per-sequence-svc/Traffic-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 943)
+++ branches/SHM-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 944)
@@ -1,5 +1,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
-PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
+#PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 #Level                         : 5
 #This is level of the whole bitstream
Index: branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.cpp	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.cpp	(revision 944)
@@ -782,4 +782,10 @@
 
 #if SVC_EXTENSION
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void TComPrediction::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+{
+  m_cUsf.upsampleBasePic( currSlice, refLayerIdc, pcUsPic, pcBasePic, pcTempPic );
+}
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -814,4 +820,5 @@
 #endif
 #endif
+#endif
 #endif //SVC_EXTENSION
 //! \}
Index: branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.h	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComPrediction.h	(revision 944)
@@ -118,4 +118,7 @@
 
 #if SVC_EXTENSION
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -135,4 +138,5 @@
 #endif
 #endif
+#endif
 #endif //SVC_EXTENSION
 };
Index: branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 944)
@@ -51,4 +51,7 @@
 }
 
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void TComUpsampleFilter::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -66,4 +69,5 @@
 #else
 Void TComUpsampleFilter::upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window )
+#endif
 #endif
 #endif
Index: branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 944)
@@ -42,5 +42,7 @@
   TComUpsampleFilter(void);
   ~TComUpsampleFilter(void);
-
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+  Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -60,4 +62,5 @@
 #endif
 #endif
+#endif
 
 };
Index: branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 944)
@@ -43,5 +43,5 @@
 #if SVC_EXTENSION
 #define MAX_LAYERS                       8      ///< max number of layers the codec is supposed to handle
-
+#define O0215_PHASE_ALIGNMENT_REMOVAL    1
 #define CONFORMANCE_BITSTREAM_MODE       1      ///< In order to generate the metadata related to conformance bitstreams
 #define SIGNALLING_BITRATE_PICRATE_FIX   1      ///< Fix for signalling of bitrate and picture rate info in VPS VUI to be more aligned to JCTVC-R1008
@@ -214,6 +214,7 @@
 #define VIEW_ID_RELATED_SIGNALING        1      ///< Introduce syntax elements view_id and view_id_val
 #define N0065_LAYER_POC_ALIGNMENT        1
-
+#if !O0215_PHASE_ALIGNMENT_REMOVAL
 #define O0215_PHASE_ALIGNMENT            1      ///< JCTVC_O0215: signal a flag to specify phase alignment case, 0: zero-position-aligned, 1: central-position-aligned,
+#endif
 #define AUXILIARY_PICTURES               1      ///< JCTVC-O0041: auxiliary picture layers
 #define R0062_AUX_PSEUDO_MONOCHROME      1      ///> JCVVC-R0063: pseudo monochrome for auxiliary pictures
Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 944)
@@ -2192,4 +2192,7 @@
           if( m_ppcTDecTop[m_layerId]->getSamplePredEnabledFlag(refLayerId) )
           {
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+            m_cPrediction.upsampleBasePic( pcSlice, refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pBaseColRec, pcPic->getPicYuvRec());
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -2226,4 +2229,5 @@
 #else
             m_cPrediction.upsampleBasePic( refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pcSlice->getBaseColPic(refLayerIdc)->getPicYuvRec(), pcPic->getPicYuvRec(), scalEL );
+#endif
 #endif
 #endif
Index: branches/SHM-dev/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 943)
+++ branches/SHM-dev/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 944)
@@ -1343,4 +1343,7 @@
             }
 #endif
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+            m_pcPredSearch->upsampleBasePic( pcSlice, refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pBaseColRec, pcPic->getPicYuvRec() );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -1373,4 +1376,5 @@
 #else
             m_pcPredSearch->upsampleBasePic( refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pcSlice->getBaseColPic(refLayerIdc)->getPicYuvRec(), pcPic->getPicYuvRec(), scalEL );
+#endif
 #endif
 #endif