Index: branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.cpp	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.cpp	(revision 946)
@@ -860,4 +860,10 @@
 
 #if SVC_EXTENSION
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void TComPrediction::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+{
+  m_cUsf.upsampleBasePic( currSlice, refLayerIdc, pcUsPic, pcBasePic, pcTempPic );
+}
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -892,4 +898,5 @@
 #endif
 #endif
+#endif
 #endif //SVC_EXTENSION
 //! \}
Index: branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.h	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibCommon/TComPrediction.h	(revision 946)
@@ -146,4 +146,7 @@
 
 #if SVC_EXTENSION
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -163,4 +166,5 @@
 #endif
 #endif
+#endif
 #endif //SVC_EXTENSION
 };
Index: branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 946)
@@ -51,4 +51,7 @@
 }
 
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+Void TComUpsampleFilter::upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -66,4 +69,5 @@
 #else
 Void TComUpsampleFilter::upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window )
+#endif
 #endif
 #endif
Index: branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.h
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 946)
@@ -42,5 +42,7 @@
   TComUpsampleFilter(void);
   ~TComUpsampleFilter(void);
-
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+  Void upsampleBasePic( TComSlice* currSlice, UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -60,4 +62,5 @@
 #endif
 #endif
+#endif
 
 };
Index: branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibCommon/TypeDef.h	(revision 946)
@@ -45,5 +45,5 @@
 #if SVC_EXTENSION
 #define MAX_LAYERS                       8      ///< max number of layers the codec is supposed to handle
-
+#define O0215_PHASE_ALIGNMENT_REMOVAL    1
 #define CONFORMANCE_BITSTREAM_MODE       1      ///< In order to generate the metadata related to conformance bitstreams
 #define SIGNALLING_BITRATE_PICRATE_FIX   1      ///< Fix for signalling of bitrate and picture rate info in VPS VUI to be more aligned to JCTVC-R1008
@@ -213,6 +213,7 @@
 #define VIEW_ID_RELATED_SIGNALING        1      ///< Introduce syntax elements view_id and view_id_val
 #define N0065_LAYER_POC_ALIGNMENT        1
-
+#if !O0215_PHASE_ALIGNMENT_REMOVAL
 #define O0215_PHASE_ALIGNMENT            1      ///< JCTVC_O0215: signal a flag to specify phase alignment case, 0: zero-position-aligned, 1: central-position-aligned,
+#endif
 #define AUXILIARY_PICTURES               1      ///< JCTVC-O0041: auxiliary picture layers
 #define R0062_AUX_PSEUDO_MONOCHROME      1      ///> JCVVC-R0063: pseudo monochrome for auxiliary pictures
Index: branches/SHM-upgrade/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibDecoder/TDecTop.cpp	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibDecoder/TDecTop.cpp	(revision 946)
@@ -2012,4 +2012,7 @@
           if( m_ppcTDecTop[m_layerId]->getSamplePredEnabledFlag(refLayerId) )
           {
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+            m_cPrediction.upsampleBasePic( pcSlice, refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pBaseColRec, pcPic->getPicYuvRec());
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -2046,4 +2049,5 @@
 #else
             m_cPrediction.upsampleBasePic( refLayerIdc, m_pcPic->getFullPelBaseRec(refLayerIdc), pcSlice->getBaseColPic(refLayerIdc)->getPicYuvRec(), m_pcPic->getPicYuvRec(), scalEL );
+#endif
 #endif
 #endif
Index: branches/SHM-upgrade/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/SHM-upgrade/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 945)
+++ branches/SHM-upgrade/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 946)
@@ -1378,4 +1378,7 @@
             }
 #endif
+#if O0215_PHASE_ALIGNMENT_REMOVAL
+            m_pcPredSearch->upsampleBasePic( pcSlice, refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pBaseColRec, pcPic->getPicYuvRec() );
+#else
 #if O0215_PHASE_ALIGNMENT
 #if O0194_JOINT_US_BITSHIFT
@@ -1408,4 +1411,5 @@
 #else
             m_pcPredSearch->upsampleBasePic( refLayerIdc, pcPic->getFullPelBaseRec(refLayerIdc), pcSlice->getBaseColPic(refLayerIdc)->getPicYuvRec(), pcPic->getPicYuvRec(), scalEL );
+#endif
 #endif
 #endif