Index: branches/SHM-dev/cfg/encoder_intra_main.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_intra_main.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_intra_main.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main        
+Profile0                      : scalable-main        
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main
 #Profile for the enhancement layer
-Profile2                      : main
+Profile2                      : scalable-main
 
 #======== Unit definition ================
Index: branches/SHM-dev/cfg/encoder_intra_main10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_intra_main10.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_intra_main10.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main10       
+Profile0                      : scalable-main10       
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main10
 #Profile for the enhancement layer
-Profile2                      : main10
+Profile2                      : scalable-main10
 
 #======== Unit definition ================
Index: branches/SHM-dev/cfg/encoder_lowdelay_main.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_main.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_lowdelay_main.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main        
+Profile0                      : scalable-main        
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main
 #Profile for the enhancement layer
-Profile2                      : main
+Profile2                      : scalable-main
 
 #======== Unit definition ================
Index: branches/SHM-dev/cfg/encoder_lowdelay_main10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_main10.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_lowdelay_main10.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main10
+Profile0                      : scalable-main10
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main10
 #Profile for the enhancement layer
-Profile2                      : main10
+Profile2                      : scalable-main10
 
 #======== Unit definition ================
Index: branches/SHM-dev/cfg/encoder_randomaccess_main.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_main.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_randomaccess_main.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main       
+Profile0                      : scalable-main       
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main
 #Profile for the enhancement layer
-Profile2                      : main
+Profile2                      : scalable-main
 
 #======== Unit definition ================
Index: branches/SHM-dev/cfg/encoder_randomaccess_main10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_main10.cfg	(revision 950)
+++ branches/SHM-dev/cfg/encoder_randomaccess_main10.cfg	(revision 951)
@@ -7,9 +7,9 @@
 NumProfileTierLevel           : 3
 #Profile for the whole bitstream
-Profile0                      : main10       
+Profile0                      : scalable-main10       
 #Profile for the base layer --- this will be ignored when BL is not HEVC
 Profile1                      : main10
 #Profile for the enhancement layer
-Profile2                      : main10
+Profile2                      : scalable-main10
 
 #======== Unit definition ================