Index: branches/HTM-11.0-dev0-Qualcomm/cfg/3D-HEVC/baseCfg_3view.cfg
===================================================================
--- branches/HTM-11.0-dev0-Qualcomm/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 955)
+++ branches/HTM-11.0-dev0-Qualcomm/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 956)
@@ -191,4 +191,8 @@
 ViewSynthesisPred                   : 0                # View synthesis prediction 
 DepthRefinement                     : 0                # Dispary refined by depth DoNBDV
+IvMvScaling                         : 1                # Interview motion vector scaling
+SubPULog2Size                       : 3                # Log2 of sub-PU size for IvMvPred (2...6)
+SubPUMPILog2Size                    : 3                # Log2 of sub-PU size for MPI (3...6)
+DBBP                                : 0                # Depth-based Block Partitioning
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/HTM-11.0-dev0-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-11.0-dev0-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 955)
+++ branches/HTM-11.0-dev0-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 956)
@@ -1591,5 +1591,9 @@
   xConfirmPara( m_pchCameraParameterFile    == 0                ,   "CameraParameterFile must be given");
   xConfirmPara( m_pchBaseViewCameraNumbers  == 0                ,   "BaseViewCameraNumbers must be given" );
+#if BUG_FIX_TK65
+  xConfirmPara( ( ((UInt) m_numberOfLayers >> 1 ) != m_cCameraData.getBaseViewNumbers().size() ) && ( m_numberOfLayers != m_cCameraData.getBaseViewNumbers().size() ),   "Number of Views in BaseViewCameraNumbers must be equal to NumberOfViews" );
+#else
   xConfirmPara( ((UInt) m_numberOfLayers >> 1 ) != m_cCameraData.getBaseViewNumbers().size(),   "Number of Views in BaseViewCameraNumbers must be equal to NumberOfViews" );
+#endif
   xConfirmPara    ( m_iCodedCamParPrecision < 0 || m_iCodedCamParPrecision > 5,       "CodedCamParsPrecision must be in range of 0..5" );
 #if H_3D_VSO
Index: branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 955)
+++ branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 956)
@@ -6830,5 +6830,7 @@
 #else
         picDepth = getSlice()->getIvPic( true, iTargetViewIdx );
+#if !BUG_FIX_TK65
         assert(picDepth != NULL);
+#endif
 #endif
         if (picDepth && bDepthRefine)
@@ -6901,5 +6903,7 @@
 #else
           TComPic* picDepth = getSlice()->getIvPic( true, pDInfo->m_aVIdxCan );
+#if !BUG_FIX_TK65
           assert(picDepth!=NULL);
+#endif
 #endif
 
@@ -6960,5 +6964,7 @@
 #else
     picDepth = getSlice()->getIvPic( true, viewIndex );
+#if !BUG_FIX_TK65
     assert(picDepth!=NULL);
+#endif
 #endif
     if (picDepth && bDepthRefine)
@@ -7060,5 +7066,7 @@
 #else
           picDepth   = getSlice()->getIvPic (true, refViewIdx );
+#if !BUG_FIX_TK65
           assert(picDepth != NULL);
+#endif
 #endif
           UInt uiPartIdx = 0;   //Notes from MTK: Please confirm that using 0 as partition index and partition address is correct for CU-level DoNBDV
Index: branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp	(revision 955)
+++ branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp	(revision 956)
@@ -1936,6 +1936,7 @@
     }
   }
+#if !BUG_FIX_TK65
   assert( foundLayerIdinNuh != -1 ); 
-
+#endif
   return foundLayerIdinNuh;
 }
Index: branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TypeDef.h	(revision 955)
+++ branches/HTM-11.0-dev0-Qualcomm/source/Lib/TLibCommon/TypeDef.h	(revision 956)
@@ -66,5 +66,5 @@
 
 #define NTT_BUG_FIX_TK54    1
-
+#define BUG_FIX_TK65        1
 
 /////////////////////////////////////////////////////////////////////////////////////////